/*
   Dico

   Luc Maranget, projet Moscova, Inria Rocquencourt
 
   Copyright 2005 Institut National de Recherche en Informatique et    
   en Automatique.  All rights reserved.  This file is distributed     
   under the terms of the Q Public License version 1.0.                
*/

class Code extends SimpleHash {
  private char [] t_decode ;

  private static String sort(String s) {
    StringBuffer tmp = new StringBuffer (s) ;
    int len = tmp.length() ;

    for (int i = 0 ; i < len ; i++) {
      char min = tmp.charAt(i) ;
      int i0 = i ;
      int j = i+1 ;
      for ( ; j < len ; j++) {
        char c = tmp.charAt(j) ;
        if (c < min) {
          min = c ;
          i0 = j ;
        }
      }
      tmp.setCharAt(i0,tmp.charAt(i)) ;
      tmp.setCharAt(i,min) ;
    }
    return tmp.toString() ;
  }

  Code (String source) {
    super() ;
    source = sort(source) ;
    int len = source.length() ;

    for (int i = 0 ; i < len ; i++)
      add(source.charAt(i)) ;
    t_decode = inverse() ;
  }

  int length() {
    return t_decode.length ;
  }


  
  private StringBuffer buff = new StringBuffer () ;

  private boolean do_code(String s, int i) {
    if (i >= s.length())
      return true ;

    char c = s.charAt(i) ;
    c = code(c) ;
    if (c != NOCHAR) {
      buff.append(c) ;
      return do_code(s, i+1) ;
    } else {
      return false ;
    }
  }

  String code(String s) {
    String r ;

    buff.setLength(0) ;
    if (do_code(s, 0)) {
      r = buff.toString() ;
    } else {
      r = null ;
    }
    return r ;
  }

  char decode(char c) {
    return t_decode[c] ;
  }

  String decode(String s) {
    int len = s.length() ;
    buff.setLength(0) ;
    for (int i = 0 ; i < len ; i++) {
      buff.append(t_decode[s.charAt(i)]) ;
    }
    String r = buff.toString() ;
    buff.setLength(0) ;
    return r ;
  }

  String decode(StringBuffer b) {
    return decode(b.toString()) ;
  }
}
