/*
   Dico

   Luc Maranget, projet Moscova, Inria Rocquencourt
 
   Copyright 2005 Institut National de Recherche en Informatique et    
   en Automatique.  All rights reserved.  This file is distributed     
   under the terms of the Q Public License version 1.0.                
*/

class Freq {
  int [] t ;

  Freq(int nchars) {
    t = new int [nchars] ;
  }


  void incr(char c) {
    t[c]++ ;
  }

  void add(char c, int x) {
    t[c] += x ;
  }

  
  char min() {
    char r = 1 ;
    int len = t.length ;
    char c ;

    for (c = 1 ; c < len && t[c] == 0; c++)
      ;
    r = c ;
    for (c++ ; c < len ; c++) {
      if (t[c] > 0 && t[c] < t[r])
        r = c ;
    }
    return r ;
  }

  char max() {
    int len = t.length ;
    char r = 1 ;
    for (char c = 2 ; c < len ; c++) {
      if (t[c] > t[r])
        r = c ;
    }
    return r ;
  }

  public String toString() {
    StringBuffer b = new StringBuffer () ;
    int len = t.length ;

    for (char c = 0 ; c < len ; c++) {
      if (t[c] >= 0) {
        b.append(" " + c + ":" + t[c]) ;
      }
    }
    return b.toString() ;
  }

}
