/*
   Dico

   Luc Maranget, projet Moscova, Inria Rocquencourt
 
   Copyright 2005 Institut National de Recherche en Informatique et    
   en Automatique.  All rights reserved.  This file is distributed     
   under the terms of the Q Public License version 1.0.                
*/

class OOptions extends Options {
  /* additional options */
  int below = 0 ;   // number of words allowed < minLen
  final static int MAXNODES=1024 ;
  final static int MAXWORDS=128 ;
  final static int MAXLETTERS=8 ;
  final static int NORMAL = 0 ;
  final static int LEXICAL = 1 ;
  final static int LOWFREQ = 2 ;
  final static int SIMPLE = 3 ;
  int mode = NORMAL ;


  void usage(String prog) {
    super.usage(prog) ;
    System.err.println("  -below n, autorise n mots de taille infrieure  minLen [dfaut " + below + "]") ;
    System.err.println("  -lowfreq, -lexical, -simple, contrle du mode d'numration") ;
  }

  int unkownOption(String prog, String [] argv, int argi) {
    if (argv[argi].compareTo("-below") == 0) {
        below = Integer.parseInt(argv[++argi]) ;
        return argi ;
       } else if (argv[argi].equals("-lowfreq")) {
        mode = LOWFREQ ;
        return argi ;
      } else if (argv[argi].equals("-lexical")) {
        mode = LEXICAL ;
        return argi ;
      } else if (argv[argi].equals("-simple")) {
        mode = SIMPLE ;
        return argi ;
      } else {
        return super.unkownOption(prog, argv, argi) ;
      }
  }

  OOptions (String prog, String [] args) {
    super(prog, args) ;
  }
}
